#property copyright " 2005-2008, BJF Trading Group"
#property link      "www.iticsoftware.com" 

//+------------------------------------------------------------------+
#define S_OK 0
#define HOUR_SEC 3600

#import "kernel32.dll"
void GetLocalTime(int& TimeArray[]);
void GetSystemTime(int& TimeArray[]);
int  GetTimeZoneInformation(int& TZInfoArray[]);
#import

#import  "NeuroGenII.dll"
  string GetProperty( int ObjectID, string Property ); //  
  bool SetProperty( int ObjectID, string Property, string Value ); // 
  int NewNeuro( int NeuroType ); //   NeuroID >= 0  -1 
  int NeuroLoad( string FileName ); //     NeuroID  -1
  bool NeuroSave( int NeuroID, string FileName ); //    
  bool NeuroInit( int NeuroID, double& Layers[], int Count ); // 
  //    NeuroID   Data, OutCnt   InCnt 
  bool NeuroPattern( int NeuroID, double& Data[], int OutCnt, int InCnt );
  //      | Data, OutCnt   InCnt 
  bool NeuroTrain( int NeuroID, double& Data[], int OutCnt, int InCnt, int Num );
  //    NeuroID -   Data, OutCnt   InCnt 
  bool NeuroCompute( int NeuroID, double& Data[], int OutCnt, int InCnt );
  bool NeuroProperty( int NeuroID ); //    NeuroID
  bool NeuroFree( int NeuroID ); //   NeuroID   
  bool NeuroSetField(string fname, string value);
  string NeuroGetField(string fname);
  int ChannelNN( double rates[][6], int tot, int siz1, int siz2, double& out[4] );
#import
//    -  NeuroType   NewNeuro()
#define NT_SOM 1 // Self Org.Map Kohhonen.
#define NT_BPR 2 // Back Propagation
#define NT_HOP 3 // Net Hopfild
#define NT_LPF 4 // Low Pass Filter
#define NT_KLF 5 // Kalman Filter
#define NT_GEN 6 // Genetic Algorithm
#define NT_WNN 7 // Wizard Neural Network
#define S_OK  0
//+------------------------------------------------------------------+
bool UseNeuro = true;
bool Training = false;
int PatternBars = 18;
int EpochCount = 100000;
int NeuronsLayer1 = 200;
int NeuronsLayer2 = 0;
int NeuronsLayer3 = 0;
double MinTeachError = 0.0000001;
double MaxError = 0.05;
int NeuroTakeProfit = 20;
int NeuroStopLoss = 109;
int NeuroLotPercent = 30;
int NeuroTimeFrame = 5;
//+------------------------------------------------------------------+

//extern bool   acc5digits=true;
extern double Lots = 1; 
extern int    LotsPercent = 10; 
 bool   ModifySLTP = true;
 int    TradingMin = 0;

double MaxSpread = 400;
int TakeProfit = 30;
int StopLoss = 109;
int MinProfitValue = 9;
int MaxLossValue = 67;
int GMT = 0; 
int StartSession1 = 16;
int EndSession1 = 23;
 int StartSession2 = 24;
int EndSession2 = 24;
int ChannelBarsOpen = 7;
int ChannelBarsClose = 13;
bool OneTrade = true;
bool ContinueAfterClose = true;
bool ShowComments = true;

int    MaxChannelSize = 0;
int    MaxChannelLength = 18;

int    NoTradeDays1[] = {0, 1, 5};
int    NoTradeDays2[] = {0, 5};

int    MaxDrawDown = 30; 
bool   TryTakeProfit = false;
bool   CheckFreezLevel = true;
int    TrailingStop = 50;

int    TradeTimeChoise = 1;
int    TradeDayOfWeek = 0;

int    SellCorrection = 0;
int    BuyCorrection = 0;
bool   CheckTimeBar = false;
bool   EqualBars = true;

bool   CheckDeleteFile = false;
int    TimeOutDeleteFile = 10;
bool   CheckSetOrder = true;
int    TimeOutSetOrder = 10;
bool   DeleteFileAfterChecking = false;
int    NumberRepeatCloseOrder = 0;

int    PersonalMagicNumber = 2509208;
bool   ShowSettings = true;
int    TimeOutComment = 3;
bool   ShowPrint = false;
bool   ShowTime = true;
bool   ShowNameID = false;
bool   ShowMagicNumber = false;

bool   ReversTrades = false;
bool   HideIndicators = false;

int    Slippage;
int    MagicNumber = 255998;
string NameID = "neural net", InitString;
double LotsForTrade;
double HighestBarsValueOpen, LowestBarsValueOpen, HighestBarsValueClose, LowestBarsValueClose;
color  BuyOrderColor = Blue;
color  SellOrderColor = Red;
int    LastOrderBar, LastOrderTicket, CurrentOrderTicket, CurrentOrderProfitPoint, CurrentOrderTrailingStop;
double LastOrderTime = 0;
double CurrentOrderProfit;
int    CounterRepeatClose = 0;
bool   fTime = true, StopTradesByMargin, LastisOrderSell, LastisOrderBuy, TryRepeatCloseOrder;
int    LastStartSession1, LastEndSession1, LastStartSession2, LastEndSession2;
bool   RepeatCloseOrder, FirstComment = false;
//string ErrorArray[4207];
int LotsDigit;
int RepeatN = 3;
//+------------------------------------------------------------------+
int NeuroNet = -1, NeuroType = NT_WNN, TrainingTime = 0,
    PatternsCount = 0;
double neuroPattern[], neuroInit[5];
string StorageFileName, nnwExt = ".nnb";
int OrderPatternTicket = 0;
int _StopLoss, _TakeProfit, _NeuroTakeProfit, _NeuroStopLoss;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   Comment("");
   Slippage=MarketInfo(Symbol(), MODE_SPREAD);
   LastOrderTime=Time[0];
   MagicNumber=PersonalMagicNumber;
   LastStartSession1=StartSession1; LastEndSession1=EndSession1; LastStartSession2=StartSession2; LastEndSession2=EndSession2;
   StartRulls();
   InitString = "TradingTime = " + StartSession1 + ".00-" + EndSession1 + ".00 and " + StartSession2 + ".00-" + EndSession2 + ".00" + "\n";
   Comments("");
   if(IsTesting() != true) {
     GMT = GetShiftGMT();
     GlobalVariableSet("GMT", GMT);
   } else if(GlobalVariableCheck("GMT") == true) GMT = GlobalVariableGet("GMT"); else GMT = 0;
   StartSession1 = CorrectGMTime(StartSession1, GMT);
   EndSession1 = CorrectGMTime(EndSession1, GMT);
   StartSession2 = CorrectGMTime(StartSession2, GMT);
   EndSession2 = CorrectGMTime(EndSession2, GMT);
   if (Digits != 4) {
     MinProfitValue = MinProfitValue*10;
     MaxLossValue = MaxLossValue*10;
     TrailingStop *= 10;
   }

  if(NeuroTimeFrame != 1 && NeuroTimeFrame != 5 && NeuroTimeFrame != 15 && NeuroTimeFrame != 30 &&
  NeuroTimeFrame != 60 && NeuroTimeFrame != 240 && NeuroTimeFrame != 1440)
  NeuroTimeFrame = Period();


  if(UseNeuro == true) {  
    StorageFileName = NameID + Symbol() + NeuroTimeFrame + nnwExt;
    ArrayResize(neuroPattern, PatternBars + 1);

    if(Training == false) {
      NeuroNet = NeuroLoad(StorageFileName);
      if(NeuroNet >= 0)
      Print("Load NeuroNet #", NeuroNet, "  File:", StorageFileName);
      else Print("Error to load File:", StorageFileName);
    } else
    if(NeuroType == NT_BPR || NeuroType == NT_WNN) {
      NeuroNet = NewNeuro(NeuroType);
      if(NeuroNet >= 0) {
        neuroInit[0] =  ArraySize(neuroPattern) - 1; // Input Layer
        neuroInit[1] =  NeuronsLayer1;
        neuroInit[2] =  NeuronsLayer2;
        neuroInit[3] =  NeuronsLayer3;
        neuroInit[4] =  1;                           // Output Layer
        NeuroInit(NeuroNet, neuroInit, 5);
        string epoch = EpochCount;
        if(NeuroType == NT_BPR) SetProperty(NeuroNet, "BPNet.EpochCount", epoch); else
        if(NeuroType == NT_WNN) {
          SetProperty(NeuroNet, "WizNet.EpochCount", epoch);
          if(MinTeachError > 0)
          SetProperty(NeuroNet, "WizNet.MinTeachError", DoubleToStr(MinTeachError, 12));
        }
        Print("Init NeuroNet #", NeuroNet, "  In:", ArraySize(neuroPattern) - 1);
      } else Print("Error to create training neuro net ", StorageFileName);
    }
    TrainingTime = TimeCurrent();
  }
  return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
{
  if(UseNeuro == true && NeuroNet >= 0) {
    if(Training == true)
    if(TrainNeuroNet(NeuroNet)) NeuroSave(NeuroNet, StorageFileName);
    NeuroFree(NeuroNet);
  }
  return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {

   if(CheckDayOfWeek(StartSession1, EndSession1) && CheckDayOfWeek(StartSession2, EndSession2)) {
     if (isOrderSell()) CloseSellOrder();
     if (isOrderBuy()) CloseBuyOrder();
     return(0);
   }

   if (!StartRulls()) return(0);

   if(IsTesting() != true) Comments("");
//
   PrepareIndicators();   
//   if (StopByMaxDrawDown()) return(0);

   if (isOrderSell() && !TimeCurrentBar())
      {
      if (isGroDtoCloseSell() || isMinProfittoClose() || isMaxLossClose() || TryToCloseAgain())
         {
         if (CurrentOrderProfitPoint>=0 && !TryTakeProfit)
            {
            CloseSellOrder();
            }
         }
      if (!ContinueAfterClose) return(0);
      }

   if (isOrderBuy() && !TimeCurrentBar())
      {
      if (isGroDtoCloseBuy() || isMinProfittoClose() || isMaxLossClose() || TryToCloseAgain())
         {
         if (CurrentOrderProfitPoint>=0 && !TryTakeProfit)
            {
            CloseBuyOrder();
            }
         }
      if (!ContinueAfterClose) return(0);
      }

   if ((OneTrade && (isOrderSell() || isOrderBuy())) ||
    Ask - Bid > MaxSpread * 0.0001 || MaxChannelLimit()) return(0);

   if (Digits > 4) {
     _TakeProfit=TakeProfit*10;
     _StopLoss=StopLoss*10;
     _NeuroTakeProfit=NeuroTakeProfit*10;
     _NeuroStopLoss=NeuroStopLoss*10;
   } else {
     _TakeProfit=TakeProfit*10;
     _StopLoss=StopLoss*10;
     _NeuroTakeProfit=NeuroTakeProfit*10;
     _NeuroStopLoss=NeuroStopLoss*10;
   }

   if (isGroDtoSell() && !TimeCurrentBar() && (isTimetoTrade(StartSession1, EndSession1) || isTimetoTrade(StartSession2, EndSession2)))
      {
         {
         if(UseNeuro == true && FillPattern() && Training == false && NeuroNet >= 0 && NeuroIndicator(NeuroNet) != OP_SELL)
           {
//           if(NeuroTakeProfit > 0 || NeuroStopLoss > 0) SendSellOrder(_NeuroStopLoss,_NeuroTakeProfit,LotsForTrade);
           if(NeuroLotPercent > 0 && NeuroLotPercent <= 100)
           SendSellOrder(_NeuroStopLoss,_NeuroTakeProfit,NormalizeDouble(LotsForTrade*NeuroLotPercent/100, LotsDigit));
           return(0);
           }
         SendSellOrder(_StopLoss,_TakeProfit,LotsForTrade);
         return(0);
         }
      }
      
   if (isGroDtoBuy() && !TimeCurrentBar() && (isTimetoTrade(StartSession1, EndSession1) || isTimetoTrade(StartSession2, EndSession2)))
      {
         {
         if(UseNeuro == true && FillPattern() && Training == false && NeuroNet >= 0 && NeuroIndicator(NeuroNet) != OP_BUY)
           {
//           if(NeuroTakeProfit > 0 || NeuroStopLoss > 0) SendBuyOrder(_NeuroStopLoss,_NeuroTakeProfit,LotsForTrade);
           if(NeuroLotPercent > 0 && NeuroLotPercent <= 100)
           SendBuyOrder(_NeuroStopLoss,_NeuroTakeProfit,NormalizeDouble(LotsForTrade*NeuroLotPercent/100, LotsDigit));
           return(0);
           }
         SendBuyOrder(_StopLoss,_TakeProfit,LotsForTrade);
         return(0);
         }
      }
      
   return(0);
}
//-------------------------------------------------------------------------- 
//-------------------------------------------------------------------------- 
bool FillPattern()
{
  double hi, lo, cl;
  if(UseNeuro != true || 1 >= ArraySize(neuroPattern)) return(false);
  if(OrderPatternTicket != 0 && Training == true && NeuroNet >= 0) SavePattern(NeuroNet);
  for(int i = 1; i < ArraySize(neuroPattern); i++) {
    hi = iHigh(Symbol(), NeuroTimeFrame, i);
    lo = iLow(Symbol(), NeuroTimeFrame, i);
    cl = iClose(Symbol(), NeuroTimeFrame, i);
    if(hi - lo > 0)
    neuroPattern[i] = (((cl - lo) - (hi - cl)) / (hi - lo)) / 2 + 0.5;
    else neuroPattern[i] = ((cl - lo) - (hi - cl)) / 2 + 0.5;
  }
  OrderPatternTicket = 0;
  return(true);
}
//-------------------------------------------------------------------------- 
bool SavePattern(int Net)
{
 int TotalOrd, TekOrd, OrdTyp;
 double TradingProfit;
// if(PatternStored == false) {
   TotalOrd = OrdersHistoryTotal();
   if(TotalOrd > 0)
   for(TekOrd = TotalOrd - 1; TekOrd >= 0; TekOrd--) {
     OrderSelect(TekOrd, SELECT_BY_POS,MODE_HISTORY); // last order
     if (OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() &&
     OrderPatternTicket == OrderTicket()) {
       TradingProfit = OrderProfit();
       OrdTyp = OrderType();
       if(TradingProfit < 0){
         if(OrdTyp == OP_BUY) OrdTyp = OP_SELL; else
         if(OrdTyp == OP_SELL) OrdTyp = OP_BUY; 
       }
       neuroPattern[0] = OrdTyp;
       if(Net >= 0) {
         if(Training == true) {
           NeuroPattern(Net, neuroPattern, 1, ArraySize(neuroPattern) - 1);
           PatternsCount++;
         }
       }// else StorePattern(Symbol() + NeuroTimeFrame + txtExt);
       return(true);
     }
   }
// }
 return(false);
}
//-------------------------------------------------------------------------- 
bool TrainNeuroNet(int Net)
{
  if(Net >= 0) {
    if(NeuroType == NT_WNN) SetProperty(Net, "WizNet.PatternsMixed", "true");
    Print("Train Neural Network on ", PatternsCount, " parrerns");
    SetProperty(Net, "Teached", "true");
    TrainingTime = TimeCurrent();
    PatternsCount = 0;
    return(true);
  } else return(false);
}
//-------------------------------------------------------------------------- 
int NeuroIndicator(int Net)
{
  int res = -1;
  if(Net >= 0 && ArraySize(neuroPattern) > 1) {
    neuroPattern[0] = res;
    NeuroCompute(Net, neuroPattern, 1, ArraySize(neuroPattern) - 1);
//    Sleep(100);
//   Print("***********",DoubleToStr(neuroPattern[0], 8)," ",DoubleToStr(neuroPattern[0], 8)," ",DoubleToStr(neuroPattern[1], 8)," ",DoubleToStr(neuroPattern[2], 8)," ",DoubleToStr(neuroPattern[3], 8)," ",DoubleToStr(neuroPattern[5], 8));
    if(neuroPattern[0] > (1.0 - MaxError)) res = OP_SELL;
    else if(neuroPattern[0] < MaxError) res = OP_BUY;
  }
  return(res);
}
//-------------------------------------------------------------------------- 
//-------------------------------------------------------------------------- 
bool StopByMaxDrawDown(){
   bool result=false;
   double CurrentMaxDrawDown;
   if (MaxDrawDown==0 || (StartSession1==0 && EndSession1==12 && StartSession2==12 && EndSession2==24)) return(result);
   if (!isTimetoTrade(StartSession1, EndSession1) && !isTimetoTrade(StartSession2, EndSession2))
      {
      Comments("StopByMaxDrawDown(): Trade allow");
      StopTradesByMargin=false;
      GlobalVariableSet("MaxAccountValue",AccountBalance());
      result=false;
      return(result);
      }
   if (StopTradesByMargin)
      {
      result=true;
      return(result);
      }
   if (GlobalVariableGet("MaxAccountValue")-AccountBalance()<0) GlobalVariableSet("MaxAccountValue",AccountBalance());
   CurrentMaxDrawDown=GlobalVariableGet("MaxAccountValue")-GlobalVariableGet("MaxAccountValue")*MaxDrawDown/100;
/*   Comment(
            "CurrentMaxDrawDown= ",CurrentMaxDrawDown,"\n",
            "MaxAccountValue= ",GlobalVariableGet("MaxAccountValue"),"\n",
            "AccountBalance()= ",AccountBalance(),"\n",
            "AccountEquity()= ",AccountEquity(),"\n"
            );*/
   if (CurrentMaxDrawDown-AccountEquity()>0)
      {
      while (isOrderBuy()) CloseBuyOrder();
      while (isOrderSell()) CloseSellOrder();
      Comments("StopByMaxDrawDown(): Trade is permitted");
      StopTradesByMargin=true;
      result=true;
      return(result);
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool TimeCurrentBar(){
   bool result=false;
   if (CheckTimeBar && Time[0]==LastOrderTime) result=true;
   return(result);
}
//-------------------------------------------------------------------------- 
bool isOrderSell(){
   bool result=false;
   int cnt=0, ticket, total;
   total=OrdersTotal();
   for (cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderType()==OP_SELL)
         {
         if (OrderMagicNumber()!=MagicNumber) continue;
         result=true;
         CurrentOrderProfit = OrderProfit();
         CurrentOrderProfitPoint = (OrderOpenPrice()-Ask)/Point;
         break;
         }
      }
   if (LastisOrderSell && !result)
      {
      if (OrderStopLoss()!=0 || OrderTakeProfit()!=0) LastOrderTime=Time[0];
      }
   LastisOrderSell=result;
   return(result);
}
//-------------------------------------------------------------------------- 
bool isOrderBuy(){
   bool result=false;
   int cnt=0, ticket, total;
   total=OrdersTotal();
   for (cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderType()==OP_BUY)
         {
         if (OrderMagicNumber()!=MagicNumber) continue;
         result=true;
         CurrentOrderProfit = OrderProfit();
         CurrentOrderProfitPoint = (Bid-OrderOpenPrice())/Point;
         break;
         }
      }
   if (LastisOrderBuy && !result)
      {
      if (OrderStopLoss()!=0 || OrderTakeProfit()!=0) LastOrderTime=Time[0];
      }
   LastisOrderBuy=result;
   return(result);
}
//-------------------------------------------------------------------------- 
bool CloseBuyOrder(){
   bool result=false;
   int cnt=0, ticket, total;
   total=OrdersTotal();
   for (cnt=0;cnt<total;cnt++)
      {
      ticket = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderType()==OP_BUY)
         {
         if (TimeCurrent() - OrderOpenTime() < TradingMin*60 || isFreezLevel()) continue;
         if (OrderMagicNumber()==MagicNumber)
            {
            if (OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,BuyOrderColor))
               {
//               Comments("Buy order closed : " + OrderClosePrice());
               result=true;
               LastOrderTime=Time[0];
//               LastDirection=OP_BUY;
               RepeatCloseOrder=false;
               }
            else
               {
//               Comments("Error close Buy order: " + PrintError(GetLastError()));
               Comments("Error close BUY order!");
               RepeatCloseOrder=true;
               }
            }
         }
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool CloseSellOrder(){
   bool result=false;
   int cnt=0, ticket, total;
   total=OrdersTotal();
   for (cnt=0;cnt<total;cnt++)
      {
      ticket = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderType()==OP_SELL)
         {
         if (TimeCurrent() - OrderOpenTime() < TradingMin*60 || isFreezLevel()) continue;
         if (OrderMagicNumber()==MagicNumber)
            {
            if (OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,SellOrderColor))
               {
//               Comments("Sell order closed : "+OrderClosePrice());
               result=true;
               LastOrderTime=Time[0];
//               LastDirection=OP_SELL;
               RepeatCloseOrder=false;
               }
            else
               {
//               Comments("Error close Sell order: " + PrintError(GetLastError()));
               Comments("Error close SELL order!");
               RepeatCloseOrder=true;
               }
            }
         }
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool TryToCloseAgain(){
   bool result=false;
   if (!RepeatCloseOrder)
      {
      CounterRepeatClose=NumberRepeatCloseOrder;
      }
   else
      {
      CounterRepeatClose=CounterRepeatClose-1;
      if (CounterRepeatClose>0)
         {
         result=true;
         }
      else
         {
         RepeatCloseOrder=false;
   //      Comments("TryToCloseAgain(): Error after repeat Close order");
         }
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool isFreezLevel()
{
   bool result=false;
   double Price, FreezLevelValue, CurrentSlippage;
   if (CheckFreezLevel)
      {
      if (OrderStopLoss()!=0 || OrderTakeProfit()!=0)
         {
         if (OrderType()==OP_BUY) Price=Bid;
         if (OrderType()==OP_SELL) Price=Ask;
         FreezLevelValue=MarketInfo(Symbol(),MODE_FREEZELEVEL)*Point;
         if (  OrderStopLoss()!=0 && FreezLevelValue>(MathAbs(Price-OrderStopLoss()  ))) result=true;
         if (OrderTakeProfit()!=0 && FreezLevelValue>(MathAbs(Price-OrderTakeProfit()))) result=true;
         }
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool SendBuyOrder(double _SBO_StopLoss, double _SBO_TakeProfit, double SBO_LotsForTrade)
{
   int ticket=0;
   RepeatCloseOrder=false;
   double SBO_StopLoss = _SBO_StopLoss;
   double SBO_TakeProfit = _SBO_TakeProfit;
   if (SBO_StopLoss!=0)
      {
      if (SBO_StopLoss < MarketInfo(Symbol(),MODE_STOPLEVEL)) SBO_StopLoss = MarketInfo(Symbol(),MODE_STOPLEVEL);
      SBO_StopLoss = NormalizeDouble(Bid - SBO_StopLoss*Point,MarketInfo(Symbol(),MODE_DIGITS));
      }
   if (SBO_TakeProfit!=0)
      {
      if (SBO_TakeProfit < MarketInfo(Symbol(),MODE_STOPLEVEL)) SBO_TakeProfit = MarketInfo(Symbol(),MODE_STOPLEVEL);
      SBO_TakeProfit = NormalizeDouble(Ask + SBO_TakeProfit*Point,MarketInfo(Symbol(),MODE_DIGITS));
      }
   if (ModifySLTP)
      {
        ticket=OrderSend(Symbol(),OP_BUY,SBO_LotsForTrade,Ask,Slippage,0,0, NameID,MagicNumber,0,BuyOrderColor);        
        if (ticket > 0 && (SBO_StopLoss!=0 || SBO_TakeProfit!=0))
        {
          OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES);
          for (int i=0; i < RepeatN; i++)
          {
            bool res = OrderModify(ticket, OrderOpenPrice(), SBO_StopLoss, SBO_TakeProfit, 0);
            if (res) break;
          }
        }
      } else {
//   ticket=OrderSend(Symbol(),OP_BUY,SBO_LotsForTrade,Ask,Slippage,SBO_StopLoss,SBO_TakeProfit, NameID,MagicNumber,0,BuyOrderColor);
   ticket=OrderSend(Symbol(),OP_BUY,SBO_LotsForTrade,Ask,Slippage,0,0, NameID,MagicNumber,0,BuyOrderColor);  
    if(ticket>0)
                  {
                   OrderSelect(ticket,SELECT_BY_TICKET);
                   OrderModify(OrderTicket(),OrderOpenPrice(),SBO_StopLoss,SBO_TakeProfit,0,BuyOrderColor);
                  }
             else
                  {
                  Print("OrderSend failed with error #",GetLastError());
                  }
      }  
   if(ticket>0)
      {
      OrderPatternTicket = ticket;
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
         {
//         Comments("Buy order opened : "+OrderOpenPrice());
         LastOrderTime=Time[0];
         LastOrderBar=Bars;
         CurrentOrderTicket=ticket;
         CurrentOrderTrailingStop=0;
         }
      }
      else 
      {
//      Comments("Error open Buy order : " + PrintError(GetLastError()));
      Comments("Error open BUY order!");
      return(false);
      }
   return(true);
}
//-------------------------------------------------------------------------- 
bool SendSellOrder(double _SSO_StopLoss, double _SSO_TakeProfit, double SSO_LotsForTrade)
{
   int ticket=0;
   RepeatCloseOrder=false;
   double SSO_StopLoss = _SSO_StopLoss;
   double SSO_TakeProfit = _SSO_TakeProfit;
   if (SSO_StopLoss!=0)
      {
      if (SSO_StopLoss < MarketInfo(Symbol(),MODE_STOPLEVEL)) SSO_StopLoss = MarketInfo(Symbol(),MODE_STOPLEVEL);
      SSO_StopLoss = NormalizeDouble(Ask + SSO_StopLoss*Point,MarketInfo(Symbol(),MODE_DIGITS));
      }
   if (SSO_TakeProfit!=0)
      {
      if (SSO_TakeProfit < MarketInfo(Symbol(),MODE_STOPLEVEL)) SSO_TakeProfit = MarketInfo(Symbol(),MODE_STOPLEVEL);
      SSO_TakeProfit = NormalizeDouble(Bid - SSO_TakeProfit*Point,MarketInfo(Symbol(),MODE_DIGITS));
      }
   if (ModifySLTP)
      {
        ticket=OrderSend(Symbol(),OP_SELL,SSO_LotsForTrade,Bid,Slippage,0,0, NameID,MagicNumber,0,SellOrderColor);      
        if (ticket > 0 && (SSO_StopLoss!=0 || SSO_TakeProfit!=0))
        {
          OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES);        
          for (int i=0; i < RepeatN; i++)
          {
            bool res = OrderModify(ticket, OrderOpenPrice(), SSO_StopLoss, SSO_TakeProfit, 0);
            if (res) break;
          }
        }
      } else {
//   ticket=OrderSend(Symbol(),OP_SELL,SSO_LotsForTrade,Bid,Slippage,SSO_StopLoss,SSO_TakeProfit, NameID,MagicNumber,0,SellOrderColor);
   ticket=OrderSend(Symbol(),OP_SELL,SSO_LotsForTrade,Bid,0,0,0, NameID,MagicNumber,0,SellOrderColor);
   
    if(ticket>0)
                  {
                   OrderSelect(ticket,SELECT_BY_TICKET);
                   OrderModify(OrderTicket(),OrderOpenPrice(),SSO_StopLoss,SSO_TakeProfit,0,SellOrderColor);
                  }
             else
                  {
                  Print("OrderSend failed with error #",GetLastError());
                  }
      }
   if(ticket>0)
      {
      OrderPatternTicket = ticket;
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
         {
//         Comments("Sell order opened : "+OrderOpenPrice());
         LastOrderTime=Time[0];
         LastOrderBar=Bars;
         CurrentOrderTicket=ticket;
         CurrentOrderTrailingStop=0;
         }
      }
      else 
      {
//      Comments("Error open Sell order : " + PrintError(GetLastError()));
      Comments("Error open SELL order!");
      return(false);
      }
   return(true);
}
//-------------------------------------------------------------------------- 
bool StartRulls()
{
   double LotsStep, LotsMin, LotsMax;

   if (!FirstComment)
      {
      FirstComment=true;
      }
   else
      {
      if (LastStartSession1!=StartSession1 || LastEndSession1!=EndSession1 || LastStartSession2!=StartSession2 || LastEndSession2!=EndSession2)
         {
         LastStartSession1=StartSession1; LastEndSession1=EndSession1; LastStartSession2=StartSession2; LastEndSession2=EndSession2;
         Comments("Another trade time EA");
         }
      }
   
   if (IsOptimization())
      {
      /*
      if (StartSession1>12) return(false);
      if (EndSession1>12) return(false);
      if (StartSession2<12) return(false);
      if (EndSession2<12) return(false);
      if (StartSession1>EndSession1 || StartSession2>EndSession2) return(false);
      */
      }
   if(Bars<100)
     {
      Comments("StartRulls() Bars less than 100");
      return(false);  
     }
   LotsStep = NormalizeDouble(MarketInfo(Symbol(), MODE_LOTSTEP),2);
   LotsMin=NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),2);
   LotsMax=NormalizeDouble(MarketInfo(Symbol(), MODE_MAXLOT),2);
   if (LotsStep==0.01) LotsDigit = 2; else LotsDigit = 1;
   //   
   if (Lots==0) LotsForTrade = NormalizeDouble(AccountFreeMargin()*LotsPercent/100000, LotsDigit);
   else LotsForTrade=Lots;
   if (LotsForTrade>LotsMax) LotsForTrade=LotsMax;
   if (LotsForTrade<LotsMin) LotsForTrade=LotsMin;
   return(true);
}
//-------------------------------------------------------------------------- 
bool isMaxLossClose(){
 if (CurrentOrderProfitPoint<0 && MaxLossValue!=0 && CurrentOrderProfitPoint<=(-MaxLossValue))
 return(true); else return(false);
}
//-------------------------------------------------------------------------- 
bool isMinProfittoClose(){
   bool result=false;
   if (CurrentOrderProfitPoint>0 && CurrentOrderProfitPoint>=MinProfitValue && MinProfitValue!=0)
      {
      result=true;
      }
   return(result);
}
//-------------------------------------------------------------------------- 
bool isGroDtoBuy() {
   bool result=false;
   if (!ReversTrades)
      {
      if (Bid < (LowestBarsValueOpen-Point*BuyCorrection) || (EqualBars && Bid <= (LowestBarsValueOpen-Point*BuyCorrection))) result=true;
      }
   else
      {
      if (Bid > HighestBarsValueOpen || (EqualBars && Bid >= HighestBarsValueOpen)) result=true;
      }
return(result);
}
//-------------------------------------------------------------------------- 
bool isGroDtoSell() {
   bool result=false;
   if (!ReversTrades)
      {
      if (Bid > (HighestBarsValueOpen+Point*SellCorrection) || (EqualBars && Bid >= (HighestBarsValueOpen+Point*SellCorrection))) result=true;
      }
   else
      {
      if (Bid < LowestBarsValueOpen || (EqualBars && Bid <= LowestBarsValueOpen)) result=true;
      }
return(result);
}
//-------------------------------------------------------------------------- 
bool isGroDtoCloseSell() {
   bool result=false;
   if (!ReversTrades)
      {
      if (Bid < (LowestBarsValueClose-Point*BuyCorrection) || (EqualBars && Bid <= (LowestBarsValueClose-Point*BuyCorrection))) result=true;
      }
   else
      {
      if (Bid > HighestBarsValueClose || (EqualBars && Bid >= HighestBarsValueClose)) result=true;
      }
return(result);
}
//-------------------------------------------------------------------------- 
bool isGroDtoCloseBuy() {
   bool result=false;
   if (!ReversTrades)
      {
      if (Bid > (HighestBarsValueClose+Point*SellCorrection) || (EqualBars && Bid >= (HighestBarsValueClose+Point*SellCorrection))) result=true;
      }
   else
      {
      if (Bid < LowestBarsValueClose || (EqualBars && Bid <= LowestBarsValueClose)) result=true;
      }
return(result);
}
//-------------------------------------------------------------------------- 
bool CheckDayOfWeek(int OpenHour, int CloseHour)
{
////////////////////////////// Check DayOfWeek
   int i, d_cnt, cur_d = DayOfWeek();
   if(OpenHour == StartSession1 && CloseHour == EndSession1) {
     d_cnt = ArraySize(NoTradeDays1);
     for(i = 0; i < d_cnt; i++) if(NoTradeDays1[i] == cur_d) return(true);
   } else if(OpenHour == StartSession2 && CloseHour == EndSession2) {
     d_cnt = ArraySize(NoTradeDays2);
     for(i = 0; i < d_cnt; i++) if(NoTradeDays2[i] == cur_d) return(true);
   }
   return(false);
////////////////////////////// Check DayOfWeek
}
//-------------------------------------------------------------------------- 
bool isTimetoTrade(int OpenHour, int CloseHour)
{
   if(CheckDayOfWeek(OpenHour, CloseHour)) return(false);
   bool result = false;
   int CurrentHour=Hour();
   if (OpenHour > 23 || OpenHour < 0 ) OpenHour = 0;
   if (CloseHour > 23 || CloseHour < 0 ) CloseHour = 0;
   if (OpenHour<CloseHour && (Hour()>=OpenHour && Hour()<CloseHour)) result=true;
   if (OpenHour>CloseHour && (Hour()>=OpenHour || Hour()<CloseHour)) result=true;
   if (DayOfWeek()!=TradeDayOfWeek && TradeDayOfWeek!=0) result = false;
   return(result);
}
//-------------------------------------------------------------------------- 
bool Comments(string CommentString){
   bool result=false;
   int i,j;
   string str="";
   if (ShowTime)
   str = str + "ServerTime = " + TimeToStr(TimeCurrent(), TIME_SECONDS) +
   " GMT = " + TimeToStr(TimeCurrent() - (GMT * HOUR_SEC), TIME_SECONDS);
   if (ShowNameID) str=str+NameID;
   if (ShowMagicNumber) str=str+"("+MagicNumber+")";
   if (ShowNameID || ShowMagicNumber) str=str+": ";
   if (ShowPrint)
      {
      Print(str+CommentString);
      }
   if (ShowSettings)
      {
      if (ShowComments) Comment(InitString+str+CommentString);
      }
   else
      {
      if (ShowComments) Comment(str+CommentString);
      }
   return(result);
}
//-------------------------------------------------------------------------- 
//-------------------------------------------------------------------------- 
bool MaxChannelLimit(){
  bool result=false;
  if(MaxChannelSize!=0) {
    bool HighPoint = High[iHighest(NULL, 0, MODE_HIGH, MaxChannelLength, 1)]/Point;
    bool LowPoint =  Low [iLowest (NULL, 0, MODE_LOW , MaxChannelLength, 1)]/Point;
    if ((HighPoint-LowPoint)>MaxChannelSize) result=true;
  }
  return(result);
}
//-------------------------------------------------------------------------- 
// 
void PrepareIndicators()
{
  double rates[][6], out[4];
  int tot = ArrayCopyRates(rates),
  siz1 = ChannelBarsOpen, siz2 = ChannelBarsClose;
  ChannelNN(rates, tot, siz1, siz2, out);
  LowestBarsValueOpen = out[0];
  HighestBarsValueOpen = out[1];
  LowestBarsValueClose = out[2];
  HighestBarsValueClose = out[3];
}
//-------------------------------------------------------------------------- 
//-------------------------------------------------------------------------- 
string FormatDateTime(int nYear,int nMonth,int nDay,int nHour,int nMin,int nSec)
  {
   string sMonth,sDay,sHour,sMin,sSec;
//----
   sMonth=100+nMonth;
   sMonth=StringSubstr(sMonth,1);
   sDay=100+nDay;
   sDay=StringSubstr(sDay,1);
   sHour=100+nHour;
   sHour=StringSubstr(sHour,1);
   sMin=100+nMin;
   sMin=StringSubstr(sMin,1);
   sSec=100+nSec;
   sSec=StringSubstr(sSec,1);
//----
   return(StringConcatenate(nYear,".",sMonth,".",sDay," ",sHour,":",sMin,":",sSec));
  }
//+------------------------------------------------------------------+
datetime GetTimeGMT()
{
   int    TimeArray[4];
   int    nYear,nMonth,nDay,nHour,nMin,nSec;
   int    TZInfoArray[43];

   
   GetLocalTime(TimeArray);

   nYear=TimeArray[0]&0x0000FFFF;
   nMonth=TimeArray[0]>>16;
   nDay=TimeArray[1]>>16;
   nHour=TimeArray[2]&0x0000FFFF;
   nMin=TimeArray[2]>>16;
   nSec=TimeArray[3]&0x0000FFFF;
   
   string st = FormatDateTime(nYear,nMonth,nDay,nHour,nMin,nSec);
   datetime d = StrToTime(st);
   
   
   int gmt_shift=0;
   int ret=GetTimeZoneInformation(TZInfoArray);
   if(ret!=0) gmt_shift=TZInfoArray[0];
   if(ret==2) gmt_shift+=TZInfoArray[42];
   return (d+gmt_shift*60);
}
//+------------------------------------------------------------------+
datetime GetShiftGMT()
{
   double d = (TimeCurrent()-GetTimeGMT());
//   return(-3600*MathRound(d/3600));
   return(MathRound(d/3600));
}
//+------------------------------------------------------------------+
datetime CorrectGMTime(datetime tim, int gmt)
{
  int res = tim + gmt;
  if(res > 24) res = res - 24;
  else if(res < 0) res = 24 + res;
  else if(res == 24) res = 0;
  return(res);
}
//+------------------------------------------------------------------+

